VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsRegistryAccess"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Sorry for non english commenting... ;o)
            '--------------------------------------------[-][x]--'
            '----------------[ Registry Access ]-----------------'
            '----------------------------------------------------'
            '     ______________________                         '
            '     Ime: clsRegistryAccess                         '
            '     Tip: Class Module                              '
            '     Verzija: 2.00                                  '
            '     Autor: Aleksandar Ruzicic - krckoorascic       '
            '     Koautor: -                                     '
            '     Kontakt: tesla.scg@gmail.com                   '
            '     Zavrseno: Subota, Novembar 13, 2004 02:38      '
            '     ______________________                         '
            '     Hvala:                                         '
            '     -The KPD-Team na njihovom API-Guide-u!         '
            '     -mladenovicz za svu pruzenu pomoc              '
            '     -svim ljudima sa EliteSecurity.org foruma      '
'-------------------------------------------------------------------------------'
'[-]EULA: (:p)                                                                    '
'Autor ovog koda nije odgovoran za bilo kakve komplikacije nastale koriscenjem  '
'ove klase, koristite ovaj kod na sopstvenu odgovornost! Kod je u potpunosti    '
'besplatan i moze biti distribuiran u bilo kom obliku sve dok ime autora i ova  '
'licenca stoje na pocetku koda. Ukoliko pronadjete neki bug obratite se autoru  '
'preko mail-a i posaljite moguce resenje (ako znate), a ako nesto izmenite      '
'dodajte vase ime u "polju" 'Koautor'.                                          '
'                                                                               '
'[-]Uvod - o Registry-ju                                                        '
'Registry je baza podataka u kojoj se cuvaju podesavanja za 32-o bitne verzije  '
'Microsoft Windows-a (9x/ME/NT/2000/XP/2003), i za aplikacije namenjene windows '
'platformama. Registry baza se nalazi u fajlovima SYSTEM.DAT i USER.DAT kao i u '
'CLASSES.DAT (u windows-u ME), koji se nalaze u %WinDir%\ folderu, za Win 9x/Me,'
'%WinDir%\System32\Config folderu za Win NT/2000/XP. Ove fajlove ne mozete rucno'
'editovati vec morate koristit tzv. Registry alate, kao sto je Registry Editor  '
'koji dolazi uz sve (32-o bitne) verzije windowsa (%WinDir%\regedit.exe).       '
'Koriscenjem ove klase mozete pristupiti registry bazi i imati sve mogucnosti   '
'kao i Registry Editor. Mislim da je sve ovo vama sigurno poznato [ako nije, ja '
'vam toplo preporucujem da se jos neko vreme ne bavite registry bazom :o)], ali '
'nije na odmet podsetiti se! Samo jos jedna napomena pre nego sto pocnete da se '
'"igrate" sa Registry-jem: BACKUPUJTE SYSTEM.DAT i USER.DAT (kao i CLASSES.DAT u'
'Win ME)!!! Jer veoma lako moze doci do pada sistema! (govorim vam ovo iz licnog'
'iskustva!). Toliko o registry-ju...                                            '
'                                                                               '
'Sadrzaj:                                                                       '
' [1] - rcMainKey (Enum)                                                        '
' [2] - rcRegType (Enum)                                                        '
' [3] - CreateKeyIfDoesntExists (Property)                                      '
' [4] - GetKeys (Private Function)                                              '
' [5] - CreateKey (Function)                                                    '
' [6] - KillKey (Function)                                                      '
' [7] - KeyExists (Function)                                                    '
' [8] - EnumKeys (Function)                                                     '
' [9] - WriteString (Function)                                                  '
' [10] - ReadString (Function)                                                  '
' [11] - WriteDWORD (Function)                                                  '
' [12] - ReadDWORD (Function)                                                   '
' [13] - WriteBinary (Function)                                                 '
' [14] - ReadBinary (Function)                                                  '
' [15] - KillValue (Function)                                                   '
' [16] - ValueExists (Function)                                                 '
' [17] - EnumValues (Function)                                                  '
' [18] - ExportToReg (Function)                                                 '
' [19] - generateReg (Private Function)                                         '
' [20] - ImportFromReg Function)                                                '
' [21] - StrToBin (Private Function)                                            '
' [22] - BinToStr (Private Function)                                            '
' [23] - isBinValid (Function)                                                  '
' _____________________________________                                         '
' [1] rcMainKey (Enum)                                                          '
' Enum (public) koji sadrzi sve root kljuceve (mada je moguce upisivati samo u  '
' sldecih 5: HKCR, HKCU, HKLM, HKUS, HKCC.                                      '
'                                                                               '
' [2] rcRegType (Enum)                                                          '
' Enum (Public) koji sadrzi sve vrste reg tipova, mada su u ovoj klasi samo     '
' pokrivena tri osnovna (REG_SZ, REG_DWORD, REG_BINARY).                        '
'                                                                               '
' [3] CreateKeyIfDoesntExists (Property)                                        '
' Property, Boolean, Let/Get; prilikom upisivanja neke vrednosti ukoliko kljuc  '
' u koji se upisuje ne postoji, ako je ovaj property podesen na true onda ce    '
' sporan kljuc biti napravljen (CreateKey).                                     '
'                                                                               '
' [4] GetKeys (Private Function)                                                '
' Privatna funkcija koja razdvaja putanju do kljuca u dva dela, MainKey i SubKey'
' takodje ova funkcija omogucuje koriscenje skracenica za root-ove, npr. umesto '
'       HKEY_LOCAL_MACHINE                                                      '
' mozete koristiti (a i ne morate)                                              '
'       HKLM                                                                    '
' skracenicu, sto je, priznacete, mnogo jednostavnije.                          '
' Skracenice su sledece (mislim da je ovo ocigledno, ali radi reda...):         '
'       HKEY_CLASSES_ROOT ........ HKCR                                         '
'       HKEY_CURRENT_USER ........ HKCU                                         '
'       HKEY_LOCAL_MACHINE ....... HKLM                                         '
'       HKEY_USERS ............... HKUS                                         '
'       HKEY_PERFORMANCE_DATA .... HKPD                                         '
'       HKEY_CURRENT_CONFIG ...... HKCC                                         '
'       HKEY_DYN_DATA ............ HKDD                                         '
'                                                                               '
' [5] CreateKey (Function)                                                      '
' Kreira novi kljuc (ako vec ne postoji) u registry-ju                          '
' CreateKey(sPath) As Long                                                      '
' sPath - string koji sadrzi putanju do kljuca koji ce kreira npr.              '
'       CreateKey("HKCU\Software\ES")                                           '
' Funcija vraca:                                                                '
' 0 - ako je doslo do greske                                                    '
' handle napravljenog kljuca - bas nekorisno :o)                                '
'                                                                               '
' [6] KillKey (Function)                                                        '
' Brise postojeci kljuc iz baze                                                 '
' KillKey(sPath) As Long                                                        '
' sPath - string koji sadrzi putanju do kljuca koji se brise npr.               '
'       KillKey("HKCU\Software\ES")                                             '
' Funkcija vraca:                                                               '
' 0 - ako je doslo do greske (kljuc nije obrisan, jer ne postoji)               '
' handle obrisanog kljuca (!?!)                                                 '
'                                                                               '
' [7] KeyExists (Function)                                                      '
' Proverava da li kljuc postoji                                                 '
' KeyExists(sPath) As Boolean                                                   '
' sPath - string koji sadrzi putanju do kljuca koji se proverava npr.           '
'        KeyExists("HKCU\Software\ES\Login")                                    '
' Funkcija vraca:                                                               '
' True - ako kljuc postoji                                                      '
' False - ako kljuc ne postoji                                                  '
'                                                                               '
' [8] EnumKeys (Function)                                                       '
' Vraca skup podkljuceva datog kljuca                                           '
' EnumKeys(sPath, Key() As String) As Long                                      '
' sPath - string koji sadrzi putanju do kljuca ciji se podkljucevi citaju       '
' Key() - prazan, nefiksiran array (!) koji ce biti popunjen imenima podkljuceva'
'       EnumKeys("HKCU\Software",Ime)                                           '
' Funkcija vraca:                                                               '
' -1 - ako je doslo do greske                                                   '
' broj podkljuceva                                                              '
' popunjen array koji je 0-based (imena nisu sortirana)                         '
'                                                                               '
' [9] WriteString (Function)                                                    '
' Upisuje string vrednost u bazu                                                '
' WriteString(sPath, sName, sValue) As Long                                     '
' sPath - string vrednost koja sadrzi putanju do kljuca u koji se upisuje       '
' sName - string koji sadrzi ime vrednosti koja se kreira/edituje               '
' sValue - string koji sadrzi vrednost koja upisuje                             '
'       WriteString("HKCU\Software\ES", "@", "http://www.elitesecurity.org")    '
' Napomena: za editovanje '(Default)' vrednosti kao ime mozete koristiti '@' ili'
' jednostavno mozete proslediti prazan string; vbNullString - ""                '
' Funkcija vraca:                                                               '
' 0 - ako je doslo do greske                                                    '
' handle kljuca u koji je upisana vrednost                                      '
'                                                                               '
' [10] ReadString (Function)                                                    '
' Vraca vrednost string vrednosti iz registry-ja                                '
' ReadString(sPath, sName, [Default]) As String                                 '
' sPath - string koji sadrzi putanju do kljuca iz kog se cita                   '
' sName - string koji sadrzi ime vrednosti koja se cita                         '
' sDefault - string, opcioni parametar (vbNullChar - Chr$(0)) koji je vracen ako'
' je doslo do greske prilikom citanja vrednosti (verovatno vrednost ne postoji) '
'       ReadString("HKCU\Software\ES", "Username", "krckoorascic")              '
' Funkcija vraca:                                                               '
' sDefault parametar - ako je doslo do greske                                   '
' string vrednost - ako je uspesno procitano                                    '
'                                                                               '
' [11] WriteDWORD (Function)                                                    '
' Upisuje DWORD vrednost u bazu                                                 '
' WriteDWORD(sPath, sName, lValue) As Long                                      '
' sPath - string koji sadrzi putanju do kljuca u koji se upisuje                '
' sName - string koji sadrzi ime vrednosti koja se kreira/edituje               '
' lValue - long vrednost koja se upisuje u bazu                                 '
'       WriteDWORD("HKCU\Software\ES", "AutoLogin", 1)                          '
' Funkcija vraca:                                                               '
' 0 - ako je doslo do greske                                                    '
' handle kljuca u koji je upisana vrednost                                      '
'                                                                               '
' [12] ReadDWORD (Function)                                                     '
' Vraca vrednost DWORD vrednosti iz registry-ja                                 '
' ReadDWORD(sPath, sName, [lDefault]) As Long                                   '
' sPath - string koji sadrzi putanju do kljuca iz koga se cita                  '
' sName - string koji sadrzi ime vrednosti koja se cita                         '
' lDefault - long, opcioni parametar (-1) koji je vracen ako je doslo do greske '
'       ReadDWORD("HKCU\Software\ES", "AutoLogin", 0)                           '
' Funkcija vraca:                                                               '
' lDefault parametar - ako je doslo do greske (vrednost verovatno nepostoji)    '
' long vrednost - ako je uspesno procitano                                      '
'                                                                               '
' [13] WriteBinary (Function)                                                   '
' Upisuje Binary vrednost u registry                                            '
' WriteBinary(sPath, sName, sValue) As Long                                     '
' sPath - string koji sadrzi putanju do kljuca u koji se upisuje vrednost       '
' sName - string koji sadrzi ime vrednosti                                      '
' sValue - string koji prestavlja vrednost koja se upisuje. Vrednost mora biti u'
' Hex formatu, ne mora biti UpperCase i mogu se koristiti razmaci posle svaka 2 '
' karaktera(nista sem "A-F", "0-9" i " "[razmak] nije dozvoljeno!)              '
'       WriteBinary("HKCU\Software\ES", "Password", "FF 20 3E 0B AF 00 00")     '
' Funkcija vraca:                                                               '
' 0 - ako je doslo do greske                                                    '
' handle kljuca u koji je upisana vrednost                                      '
'                                                                               '
' [14] ReadBinary (Function)                                                    '
' Vraca string koji predstavlja binary vrednost u registry-ju                   '
' ReadBinary(sPath, sName, [sDefault]) As String                                '
' sPath - string koji sadrzi putanju do lkuca iz koga se cita vrednost          '
' sName - string koji sadrzi ime vrednosti koja se cita                         '
' sDefault - string, opcioni parametar (vbNullChar - Chr$(0)) koji je vracen ako'
' je doslo do greske (kljuc, ili vrednost ne postoji)                           '
'        ReadBinary("HKCU\Software\ES", "Password", "FF 20 3E 0B AF 00 00")     '
' Funkcija vraca:                                                               '
' sDefault parametar - ako je doslo do greske prilikom citanja                  '
' string vrednost - ako je uspesno procitano (npr. "3E BE 00 00")               '
'                                                                               '
' [15] KillValue (Function)                                                     '
' Brise bilo koju vrednost iz registry-ja                                       '
' KillValue(sPath, sName) As Long                                               '
' sPath - string koji sadrzi putanju do kljuca u kome se nalazi vrednost        '
' sName - string koji sadrzi ime vrednosti koja se brise                        '
'        KillValue("HKCU\Software\ES", "Password")                              '
' Funkcija vraca:                                                               '
' 0 - ako je doslo do greske (vrednost nije obrisana)                           '
' handle kljuca u kome se nalazila vrednost (obrisano)                          '
'                                                                               '
' [16] ValueExists (Function)                                                   '
' Proverava da li neka vrednost postoji                                         '
' ValueExists(sPath, sName) As Boolean                                          '
' sPath - string koji sadrzi putanju do kljuca u kome se nalazi vrednost        '
' sName - string koji sadrzi ime vrednosti koja se proverava                    '
'       ValueExists("HKCU\Software\ES", "Username")                             '
' Funkcija vraca:                                                               '
' True - ako vrednost postoji                                                   '
' False - ako vrednost ne postoji                                               '
'                                                                               '
' [17] EnumValues (Function)                                                    '
' Vraca skupove imena vrednosti i vrednosti jednog kljuca                       '
' EnumValues(sPath, sName(), sValue(), [OnlyType]) As Long                      '
' sPath - string koji sadrzi putanju do kljuca iz koga se 'vade' vrednosti      '
' sName() - prazan, nefiksiran (!) string array koji ce biti ispunjen imenima   '
' sValue() - prazan, nefiksiran (!) variant array koji ce biti ispunjen         '
' vrednostima (ni jedan array nije sortiran)                                    '
' OnlyType - rcRegType, opcioni parametar (REG_NONE - 0) koji prestavlja filter '
' za citanje vrednosti (ako je OnlyType REG_SZ, samo string vrednosti ce biti   '
' iscitane, ako OnlyType nije dat [REG_NONE] onda su sve tri vrste vracene.     '
'        EnumValues("HKCU\Software", Ime, Vrednost, REG_BINARY)                 '
' Funkcija vraca:                                                               '
' -1 - ako je doslo do greske                                                   '
' broj procitanih vrednosti                                                     '
' popunjene array-e (imena i vrednosti) koji su 0-based                         '
'                                                                               '
' [18] ExportToReg (Function)                                                   '
' Generise .reg fajl (isto kao i Registry Editor)                               '
' ExportToReg(sPath, sRegFile [Output]) As Long                                 '
' sPath - string koji sadrzi putanju do kljuca od koga se pocinje               '
' sRegFile - string koji predstavlja putanju do .reg fajla (path\filename) koji '
' ce biti kreiran, ako fajl vec postoji bice vracena greska.                    '
' Output - textbox, opcioni parametar. Ako je naznacen u textboxu ce biti upisan'
' kljuc koji se trenutno cita (cisto da prikaze da se nesto desava, jer na malo '
' sporijim masinama moze da potraje ako se ceo root eksportuje)                 '
'        ExportToReg("HKCU\Software\ES", "C:\ES.reg")                           '
' Funkcija vraca:                                                               '
' 0 - ako je doslo do greske                                                    '
' 1 - ako je reg fajl uspesno generisan                                         '
'                                                                               '
' [19] generateReg (Private Function)                                           '
' Privatna rekruzivna funkcija koja zapravo vrsi eksportovanje, pozvana je od   '
' strane ExportToReg funkcije sa istim parametrima.                             '
' Funkcija vraca:                                                               '
' False - ako je doslo do greske                                                '
' True - ukoliko je uspesno iscitan kljuc (i upisan u reg)                      '
'                                                                               '
' [20] ImportFromReg (Function)                                                 '
' Ubacuje .reg fajl u registry bazu (isto kao i Registry Editor)                '
' ImportFromReg(sRegFile) As Long                                               '
' sRegFile - string koji sadrzi putanju do reg fajla koji se ubacuje u bazu     '
'       ImportFromReg("C:\ES.reg")                                              '
' Funkcija vraca:                                                               '
' 0 - ako je doslo do greske (ili ako fajl ne postoji)                          '
' 1 - ako je uspeno ubaceno u registry                                          '
'                                                                               '
' [21] StrToBin (Private Function)                                              '
' Koristi se kog WriteBinary funkcije; prebacuje npr. "BE 3E FF AB" u ">"    '
' (vrednost koja ce biti pretvorena u byte array i snimljena u bazu)            '
'                                                                               '
' [22] BinToStr (Private Function)                                              '
' Koristi se kog ReadBinary funkcije; prebacuje npr. ">" u "BE 3E FF AB"     '
' (vrednost u, nama, razumljivom formatu)                                       '
'                                                                               '
' [23] isBinValid (Function)                                                    '
' Proverava da li je data vrednost ispravna (za WriteBinary funkciju).          '
' isBinValid(sBin) As Boolean                                                   '
' sBin - string kome se proverava validnost                                     '
'        isBinValid("3E BE 00 AS") - ovde ce vratiti False                      '
' Funkcija vraca:                                                               '
' True - ukoliko string ne sadrzi nista sem "A"-"F" 0-9 i " "(razmak)           '
' False - ukoliko string nije ispravan (za upisivanje u bazu)                   '
'                                                                               '
'-------------------------------------------------------------------------------'
'Copyright  2004, krckoorascic, tesla.scg@gmail.com                            '
'-------------------------------------------------------------------------------'

'----[ API's ]----'
Private Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Private Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, lpcbName As Long, ByVal lpReserved As Long, ByVal lpClass As String, lpcbClass As Long, lpftLastWriteTime As Any) As Long
Private Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Private Declare Function RegQueryValueExA Lib "advapi32.dll" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByRef lpData As Long, lpcbData As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long
Private Declare Function RegSetValueExA Lib "advapi32.dll" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByRef lpData As Long, ByVal cbData As Long) As Long
Private Declare Function RegSetValueExB Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByRef lpData As Byte, ByVal cbData As Long) As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long

'----[ Constants ]----'
Private Const ERROR_SUCCESS = 0&
Private Const ERROR_BADDB = 1009&
Private Const ERROR_BADKEY = 1010&
Private Const ERROR_CANTOPEN = 1011&
Private Const ERROR_CANTREAD = 1012&
Private Const ERROR_CANTWRITE = 1013&
Private Const ERROR_OUTOFMEMORY = 14&
Private Const ERROR_INVALID_PARAMETER = 87&
Private Const ERROR_ACCESS_DENIED = 5&
Private Const ERROR_NO_MORE_ITEMS = 259&
Private Const ERROR_MORE_DATA = 234&
Private Const KEY_QUERY_VALUE = &H1&
Private Const KEY_SET_VALUE = &H2&
Private Const KEY_CREATE_SUB_KEY = &H4&
Private Const KEY_ENUMERATE_SUB_KEYS = &H8&
Private Const KEY_NOTIFY = &H10&
Private Const KEY_CREATE_LINK = &H20&
Private Const READ_CONTROL = &H20000
Private Const WRITE_DAC = &H40000
Private Const WRITE_OWNER = &H80000
Private Const SYNCHRONIZE = &H100000
Private Const STANDARD_RIGHTS_REQUIRED = &HF0000
Private Const STANDARD_RIGHTS_READ = READ_CONTROL
Private Const STANDARD_RIGHTS_WRITE = READ_CONTROL
Private Const STANDARD_RIGHTS_EXECUTE = READ_CONTROL
Private Const STANDARD_RIGHTS_ALL = &H1F0000
Private Const KEY_READ = STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY
Private Const KEY_WRITE = STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY
Private Const KEY_EXECUTE = KEY_READ
Private Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))

'----[ Enums ]----'
Public Enum rcMainKey
    HKEY_CLASSES_ROOT = &H80000000
    HKEY_CURRENT_USER = &H80000001
    HKEY_LOCAL_MACHINE = &H80000002
    HKEY_USERS = &H80000003
    HKEY_PERFORMANCE_DATA = &H80000004
    HKEY_CURRENT_CONFIG = &H80000005
    HKEY_DYN_DATA = &H80000006
End Enum

Public Enum rcRegType
    REG_NONE = 0
    REG_SZ = 1
    REG_EXPAND_SZ = 2
    REG_BINARY = 3
    REG_DWORD = 4
    REG_DWORD_LITTLE_ENDIAN = 4
    REG_DWORD_BIG_ENDIAN = 5
    REG_LINK = 6
    REG_MULTI_SZ = 7
    REG_RESOURCE_LIST = 8
    REG_FULL_RESOURCE_DESCRIPTOR = 9
    REG_RESOURCE_REQUIREMENTS_LIST = 10
End Enum

'----[ Dim's ]----'
Private hKey             As Long
Private mainKey          As Long
Private sKey             As String
Private lBufferSize      As Long
Private lDataSize        As Long
Private ByteArray()      As Byte
Private createNoExists   As Boolean

'----[ CreateKeyIfDoesntExists ]----'
Public Property Let CreateKeyIfDoesntExists(ByVal offon As Boolean)
    createNoExists = offon 'no needs for error handler ;o)
End Property
Public Property Get CreateKeyIfDoesntExists() As Boolean
    CreateKeyIfDoesntExists = createNoExists ' here too...
End Property
'----[ GetKeys ]----'
Private Function GetKeys(sPath As String, sKey As String) As rcMainKey
112: On Error GoTo errH
113:    Dim pos As Integer, mk As String
    
114:    sPath = Replace$(sPath, "HKEY_CURRENT_USER", "HKCU", , , vbTextCompare)
115:    sPath = Replace$(sPath, "HKEY_LOCAL_MACHINE", "HKLM", , , vbTextCompare)
116:    sPath = Replace$(sPath, "HKEY_CLASSES_ROOT", "HKCR", , , vbTextCompare)
117:    sPath = Replace$(sPath, "HKEY_USERS", "HKUS", , , vbTextCompare)
118:    sPath = Replace$(sPath, "HKEY_PERFORMANCE_DATA", "HKPD", , , vbTextCompare)
119:    sPath = Replace$(sPath, "HKEY_DYN_DATA", "HKDD", , , vbTextCompare)
120:    sPath = Replace$(sPath, "HKEY_CURRENT_CONFIG", "HKCC", , , vbTextCompare)
    
121:    pos = InStr(1, sPath, "\")

122:    If (pos = 0) Then
123:        mk = UCase$(sPath)
124:        sKey = ""
125:    Else
126:        mk = UCase$(Left$(sPath, 4))
127:        sKey = Right$(sPath, Len(sPath) - pos)
128:    End If
    
129:    Select Case mk
            Case "HKCU": GetKeys = HKEY_CURRENT_USER
131:        Case "HKLM": GetKeys = HKEY_LOCAL_MACHINE
132:        Case "HKCR": GetKeys = HKEY_CLASSES_ROOT
133:        Case "HKUS": GetKeys = HKEY_USERS
134:        Case "HKPD": GetKeys = HKEY_PERFORMANCE_DATA
135:        Case "HKDD": GetKeys = HKEY_DYN_DATA
136:        Case "HKCC": GetKeys = HKEY_CURRENT_CONFIG
137:    End Select
138:    Exit Function 'exit before error handler
errH:
'      LogError "GetKeys", "clsRegistryAccess.cls", sPath & ", " & sKey, _
'                                                   Err.Description, Err.Number, Erl
      Err.Clear
      Resume Next
End Function
'----[ CreateKey ]----'
Public Function CreateKey(ByVal sPath As String) As Long
139: On Error GoTo errH
140:    hKey = GetKeys(sPath, sKey)

141:    If (RegCreateKey(hKey, sKey, mainKey) = ERROR_SUCCESS) Then
142:        RegCloseKey mainKey
143:        CreateKey = mainKey 'uspesno kreiran kljuc
145:    Else
146:        CreateKey = 0 'greska
147:    End If
148:    Exit Function
errH:
'    LogError "CreateKey", "clsRegistryAccess.cls", sPath, Err.Description, _
'                                                          Err.Number, Erl
    Err.Clear
    Resume Next
End Function
'----[ KillKey ]----'
Public Function KillKey(ByVal sPath As String) As Long
149: On Error GoTo errH
150:    hKey = GetKeys(sPath, sKey)

151:    If (RegOpenKeyEx(hKey, sKey, 0, KEY_ALL_ACCESS, mainKey) = ERROR_SUCCESS) Then
152:        RegDeleteKey mainKey, ""   'izbrisemo kljuc
153:        RegCloseKey mainKey
154:        KillKey = mainKey 'uspesno izbrisan kljuc
155:    Else
156:        KillKey = 0 'greska
157:    End If
158:    Exit Function
errH:
'    LogError "KillKey", "clsRegistryAccess.cls", sPath, Err.Description, _
'                                                        Err.Number, Erl
    Err.Clear
    Resume Next
End Function
'----[ KeyExists ]----'
Public Function KeyExists(ByVal sPath As String) As Boolean
159: On Error GoTo errH
160:    hKey = GetKeys(sPath, sKey)

161:    If (RegOpenKeyEx(hKey, sKey, 0, KEY_ALL_ACCESS, mainKey) = ERROR_SUCCESS) Then
162:        KeyExists = True 'postoji
163:        RegCloseKey mainKey
164:    Else
165:        KeyExists = False ' ne postoji
166:    End If
167:    Exit Function
errH:
'    LogError "KeyExists", "clsRegistryAccess.cls", sPath, Err.Description, _
'                                                          Err.Number, Erl
    Err.Clear
    Resume Next
End Function
'----[ EnumKeys ]----'
Public Function EnumKeys(ByVal sPath As String, Key() As String) As Long
168: On Error GoTo errH
169:    Dim sName As String, retVal As Long
    
170:    hKey = GetKeys(sPath, sKey)
    
171:    If (RegOpenKey(hKey, sKey, mainKey) = ERROR_SUCCESS) Then

172:        EnumKeys = 0 'vraceni array je 0-based
173:        sName = Space(255)
174:        retVal = Len(sName)
        
175:        While RegEnumKeyEx(mainKey, EnumKeys, sName, retVal, ByVal 0&, _
                           vbNullString, ByVal 0&, ByVal 0&) <> ERROR_NO_MORE_ITEMS
            
176:            ReDim Preserve Key(EnumKeys) 'povecavamo array (+1)
            
177:            Key(EnumKeys) = Left$(sName, retVal) 'dodajemo ime kluca u array
                        
            'pripremamo vrednosti za sledeci kljuc
178:            EnumKeys = EnumKeys + 1
179:            sName = Space(255)
180:            retVal = Len(sName)
            
181:        Wend
    
182:        RegCloseKey mainKey
183:    Else
184:        EnumKeys = -1 'kljuc ne postoji
185:    End If
186:    Exit Function
errH:
'    LogError "EnumKeys", "clsRegistryAccess.cls", sPath, Err.Description, _
'                                                         Err.Number, Erl
    Err.Clear
    Resume Next
End Function
'----[ WriteString ]----'
Public Function WriteString(ByVal sPath As String, ByVal sName As String, _
                                                   ByVal sValue As String) As Long
187: On Error GoTo errH

188:    If (KeyExists(sPath) = False) Then 'ako kljuc ne postoji,
189:        If (createNoExists = True) Then 'i ako je CreateKeyIfDoesntExists = True
190:            CreateKey sPath  ' napravimo ga ;o)
191:        Else
192:            WriteString = 0 'greska!
193:            Exit Function
194:        End If
195:    End If
    
196:    hKey = GetKeys(sPath, sKey)
    
197:    If (sName = "@") Then sName = "" '(Default)
    
198:    If (RegOpenKeyEx(hKey, sKey, 0, KEY_WRITE, mainKey) = ERROR_SUCCESS) Then
199:        If (RegSetValueEx(mainKey, sName, 0, REG_SZ, ByVal sValue, Len(sValue)) = ERROR_SUCCESS) Then
200:            RegCloseKey mainKey
201:            WriteString = mainKey 'uspesno sacuvano!
202:        Else
203:            WriteString = 0 'greska
204:      End If
205:    Else
206:         WriteString = 0 'greska
207:    End If
208:    Exit Function
errH:
'    LogError "WriteString", "clsRegistryAccess.cls", sPath & ", " & sName & ", " _
'                                         & sValue, Err.Description, Err.Number, Erl
    Err.Clear
    Resume Next
End Function
'----[ ReadString ]----'
Public Function ReadString(ByVal sPath As String, ByVal sName As String, _
                           Optional sDefault As String = vbNullChar) As String
209: On Error GoTo errH
210:    Dim sData As String, lDuz As Long
    
211:    hKey = GetKeys(sPath, sKey)

212:    If (RegOpenKeyEx(hKey, sKey, 0, KEY_READ, mainKey) = ERROR_SUCCESS) Then
213:        sData = Space(255)     'kreiramo buffer
214:        lDuz = Len(sData)
215:        If (RegQueryValueEx(mainKey, sName, 0, REG_SZ, sData, lDuz) = ERROR_SUCCESS) Then
216:            RegCloseKey mainKey
217:            sData = Trim$(sData) 'uklanjamo razmake na pocetku i na kraju stringa
218:            ReadString = Left$(sData, Len(sData) - 1) 'vracamo procitanu vrednost
219:        Else 'ako je doslo do greske (mozda vrednost ne postoji)
220:                ReadString = sDefault 'vracamo default vrednost
221:        End If
222:    Else
223:        ReadString = sDefault
224:    End If
225:    Exit Function
errH:
'    LogError "ReadString", "clsRegistryAccess.cls", sPath & ", " & sName & _
'                           ", [" & sDefault & "]", Err.Description, Err.Number, Erl
    Err.Clear
    Resume Next
End Function
'----[ WriteDWORD ]----'
Public Function WriteDWORD(ByVal sPath As String, ByVal sName As String, _
                                                  ByVal lValue As Long) As Long
226: On Error GoTo errH
227:    If (KeyExists(sPath) = False) Then 'ako kljuc ne postoji,
228:        If (createNoExists = True) Then 'i ako je CreateKeyIfDoesntExists = True
229:            CreateKey sPath  ' napravimo ga ;o)
230:        Else
231:            WriteDWORD = 0 'greska!
232:            Exit Function
233:        End If
234:    End If

235:    hKey = GetKeys(sPath, sKey)

236:    If (RegOpenKeyEx(hKey, sKey, 0, KEY_WRITE, mainKey) = ERROR_SUCCESS) Then
237:        If (RegSetValueExA(mainKey, sName, 0, REG_DWORD, lValue, 4) = ERROR_SUCCESS) Then
238:            RegCloseKey mainKey
239:            WriteDWORD = mainKey 'uspesno ubaceno u bazu
240:        Else
241:            WriteDWORD = 0 'greska
242:        End If
243:    Else
245:        WriteDWORD = 0 'greska
246:    End If
247:    Exit Function
errH:
'    LogError "WriteDWORD", "clsRegistryAccess.cls", sPath & ", " & sName & _
'                                    CStr(lValue), Err.Description, Err.Number, Erl
    Err.Clear
    Resume Next
End Function
'----[ ReadDWORD ]----'
Public Function ReadDWORD(ByVal sPath As String, ByVal sName As String, _
                         Optional lDefault As Long = -1) As Long
248: On Error GoTo errH
249:    Dim lData As Long
    
250:    hKey = GetKeys(sPath, sKey)
    
251:    If (RegOpenKeyEx(hKey, sKey, 0, KEY_READ, mainKey) = ERROR_SUCCESS) Then
252:        If (RegQueryValueExA(mainKey, sName, 0, REG_DWORD, lData, 4) = ERROR_SUCCESS) Then
253:            RegCloseKey mainKey
254:            ReadDWORD = lData
255:        Else
256:            ReadDWORD = lDefault 'vrednost ne postoji
257:        End If
258:    Else
259:        ReadDWORD = lDefault 'izgleda da kljuc ne postoji!
260:    End If
261:    Exit Function
errH:
'    LogError "ReadDWORD", "clsRegistryAccess.cls", sPath & ", " & sName & _
'                      ", [" & CStr(lDefault) & "]", Err.Description, Err.Number, Erl
    Err.Clear
    Resume Next
End Function
'----[ WriteBinary ]----'
Public Function WriteBinary(ByVal sPath As String, ByVal sName As String, _
                                                   ByVal sValue As String) As Long
262: On Error GoTo errH
263:    Dim l As Long, lDuz As Long, B() As Byte, sVal As String
    
264:    If (KeyExists(sPath) = False) Then 'ako kljuc ne postoji,
265:        If (createNoExists = True) Then 'i ako je CreateKeyIfDoesntExists = True
266:            CreateKey sPath  ' napravimo ga ;o)
267:        Else
268:            WriteBinary = 0 'greska!
269:            Exit Function
270:        End If
271:    End If

272:    hKey = GetKeys(sPath, sKey)
    
    '"prevodimo" vrednost
273:    sVal = StrToBin(sValue)
   
274:    If (RegOpenKeyEx(hKey, sKey, 0, KEY_WRITE, mainKey) = ERROR_SUCCESS) Then
      
275:        lDuz = Len(sVal)
276:        ReDim B(lDuz) As Byte
      
277:        For l = 1 To lDuz 'pravimo byte array
278:            B(l) = Asc(Mid$(sVal, l, 1))
279:        Next
        
280:        If (lDuz = 0) Then ' (zero-length binary value)
281:            ReDim B(1) As Byte
282:            B(1) = 0
283:        End If
      
284:        If (RegSetValueExB(mainKey, sName, 0, REG_BINARY, B(1), lDuz) = ERROR_SUCCESS) Then
285:            RegCloseKey mainKey
286:            WriteBinary = mainKey 'uspesno upisano u bazu
287:        Else
288:            WriteBinary = 0 'greska
289:        End If
290:    Else
291:         WriteBinary = 0 'kljuc ne postoji
292:    End If
293:    Exit Function
errH:
'    LogError "WriteBinary", "clsRegistryAccess.cls", sPath & ", " & sName & ", " & _
'                                  StrToBin(sValue), Err.Description, Err.Number, Erl
    Err.Clear
    Resume Next
End Function
'----[ ReadBinary ]----'
Public Function ReadBinary(ByVal sPath As String, ByVal sName As String, _
                           Optional sDefault As String = vbNullString) As String
294: On Error GoTo errH
295:    Dim lDuz As Long, sData As String
    
296:    hKey = GetKeys(sPath, sKey)
    
297:    If (RegOpenKeyEx(hKey, sKey, 0, KEY_READ, mainKey) = ERROR_SUCCESS) Then
298:        lDuz = 1
299:        RegQueryValueEx mainKey, sName, 0, REG_BINARY, 0, lDuz
300:        sData = Space(lDuz)
301:        If (RegQueryValueEx(mainKey, sName, 0, REG_BINARY, sData, lDuz) = ERROR_SUCCESS) Then
302:            RegCloseKey mainKey
303:            ReadBinary = Trim$(BinToStr(sData))
304:        Else
305:            ReadBinary = sDefault
306:        End If
307:    Else
308:        ReadBinary = sDefault
309:    End If
310:    Exit Function
errH:
'    LogError "ReadBinary", "clsRegistryAccess.cls", sPath & ", " & sName & ", " & _
'                             "[" & sDefault & "]", Err.Description, Err.Number, Erl
    Err.Clear
    Resume Next
End Function
'----[ KillValue ]----'
Public Function KillValue(ByVal sPath As String, ByVal sName As String) As Long
311: On Error GoTo errH
312:    hKey = GetKeys(sPath, sKey)

313:    If (RegOpenKeyEx(hKey, sKey, 0, KEY_READ, mainKey) = ERROR_SUCCESS) Then
314:        RegDeleteValue mainKey, sName 'brisemo vrednost
315:        RegCloseKey mainKey
316:        KillValue = mainKey
317:    Else
318:        KillValue = 0
319:    End If
320:    Exit Function
errH:
'    LogError "KillValue", "clsRegistryAccess.cls", sPath & ", " & sName, _
'                                                   Err.Description, Err.Number, Erl
    Err.Clear
    Resume Next
End Function
'----[ ValueExists ]----'
Public Function ValueExists(ByVal sPath As String, ByVal sName As String) As Boolean
321: On Error GoTo errH
322:    hKey = GetKeys(sPath, sKey)
323:    Dim sData As String
324:    If (RegOpenKeyEx(hKey, sKey, 0, KEY_READ, mainKey) = ERROR_SUCCESS) Then
325:        If (RegQueryValueEx(mainKey, sName, 0, 0, sData, 1) = ERROR_SUCCESS) Then
326:            RegCloseKey mainKey
327:            ValueExists = True
328:        Else
329:            ValueExists = False 'vrednost ne postoji
330:        End If
331:    Else
332:        ValueExists = False 'izgleda da kljuc ne postoji
333:    End If
334:    Exit Function
errH:
'    LogError "ValueExists", "clsRegistryAccess.cls", sPath & ", " & sName, _
'                                                   Err.Description, Err.Number, Erl
    Err.Clear
    Resume Next
End Function
'----[ EnumValues ]----'
Public Function EnumValues(ByVal sPath As String, sName() As String, _
                sValue() As Variant, Optional OnlyType As rcRegType = -1) As Long
335: On Error GoTo errH
336:    Dim mainKey As Long, rName As String, Cnt As Long
337:    Dim rData As String, rType As Long, RetData As Long
    
338:    hKey = GetKeys(sPath, sKey)
    
339:    If RegOpenKey(hKey, sKey, mainKey) = ERROR_SUCCESS Then
        
340:        Cnt = 0
341:        rName = Space(255)
342:        rData = Space(255)
343:        retVal = 255
345:        RetData = 255
        
346:        While RegEnumValue(mainKey, Cnt, rName, retVal, 0, _
                           rType, ByVal rData, RetData) <> ERROR_NO_MORE_ITEMS
347:            If RetData > 0 Then
                
348:                If (OnlyType = -1) Or (OnlyType = rType) Then 'da li je trazeni tip?
                
349:                    ReDim Preserve sName(EnumValues) As String 'uvacavamo array-e
350:                    ReDim Preserve sValue(EnumValues) As Variant
                
351:                    sName(EnumValues) = Left$(rName, retVal)
                
352:                    If (rType = REG_BINARY) Then 'prebacujmo u citljivu vrednost
353:                        sValue(EnumValues) = ReadBinary(sPath, sName(EnumValues))
354:                    ElseIf (rType = REG_DWORD) Then
355:                        sValue(EnumValues) = ReadDWORD(sPath, sName(EnumValues))
356:                    ElseIf (rType = REG_SZ) Then
357:                        sValue(EnumValues) = ReadString(sPath, sName(EnumValues), "")
358:                    End If
                    
359:                    EnumValues = EnumValues + 1
                
360:                End If
                
361:                Cnt = Cnt + 1
362:                rName = Space(255)
363:                rData = Space(255)
364:                retVal = 255
365:                RetData = 255
                    
366:            End If
            
367:        Wend
        
368:        RegCloseKey hKey
369:    Else
370:        EnumValues = -1
371:    End If
372:    Exit Function
errH:
'    LogError "EnumValues", "clsRegistryAccess.cls", sPath, Err.Description, _
'                                                           Err.Number, Erl
    Err.Clear
    Resume Next
End Function
'----[ ExportToReg ]----'
Public Function ExportToReg(ByVal sPath As String, ByVal sRegFile As String, _
                                         Optional ByVal Output As TextBox) As Long
373: On Error GoTo errH
374:    Dim opened As Boolean, fn As Integer
    
375:    If (Dir(sRegFile) <> "") Then 'fajl vec postoji
376:        ExportToReg = 0 'greska
377:        Exit Function
378:    End If
    
379:    fn = FreeFile
380:    Open sRegFile For Output As #fn
381:        opened = True
382:        Print #fn, "REGEDIT4" & vbCrLf
383:    Close #fn
384:    opened = False
    
386:    If (generateReg(sPath, sRegFile, Output) = False) Then GoTo errH
    
387:    ExportToReg = 1 'uspesno generisan reg fajl
388:    Exit Function
errH:
    On Error Resume Next
    If (opened = True) Then Close #fn
    ExportToReg = 0
'    LogError "ExportToReg", "clsRegistryAccess.cls", sPath & ", " & sRegFile & _
'                   ", [" & TypeName(Output) & "]", Err.Description, Err.Number, Erl
End Function
'----[ generateReg ]----'
Private Function generateReg(ByVal sPath As String, sRegFile As String, _
                                            Optional Output As TextBox) As Boolean
389: On Error GoTo errH
390:    Dim keyName() As String, aName() As String, aValue() As Variant, x As Integer
391:    Dim u As Long, fn As Integer, tmp As String, opened As Boolean, l As Long
392:    Dim hasOutput As Boolean, nuls As String
    
393:    hasOutput = Not IsMissing(Output)
    
394:    sPath = Replace(sPath, "HKCU", "HKEY_CURRENT_USER", , , vbTextCompare)
395:    sPath = Replace(sPath, "HKLM", "HKEY_LOCAL_MACHINE", , , vbTextCompare)
396:    sPath = Replace(sPath, "HKCR", "HKEY_CLASSES_ROOT", , , vbTextCompare)
397:    sPath = Replace(sPath, "HKUS", "HKEY_USERS", , , vbTextCompare)
398:    sPath = Replace(sPath, "HKPD", "HKEY_PERFORMANCE_DATA", , , vbTextCompare)
399:    sPath = Replace(sPath, "HKDD", "HKEY_DYN_DATA", , , vbTextCompare)
340:    sPath = Replace(sPath, "HKCC", "HKEY_CURRENT_CONFIG", , , vbTextCompare)
    
341:    If (hasOutput = True) Then
342:        DoEvents
343:        Output.Text = sPath
344:    End If
        
345:    fn = FreeFile
346:    Open sRegFile For Append As #fn 'Append - dopisujemo!
347:        Print #fn, "[" & sPath & "]"
348:        If (ReadString(sPath, "") <> vbNullChar) Then '(Default)
349:            Print #fn, "@=" & Chr$(34) & ReadString(sPath, "", "") & Chr$(34)
350:        End If
        
351:        u = EnumValues(sPath, aName, aValue, REG_SZ) - 1
352:        For l = 0 To u
353:            If (Len(aName(l)) > 0) Then
354:                Print #fn, Chr$(34) & aName(l) & Chr$(34) & "=" & _
                           Chr$(34) & aValue(l) & Chr$(34)
356:            End If
357:        Next
358:        u = EnumValues(sPath, aName, aValue, REG_BINARY) - 1
359:        For l = 0 To u
360:            Print #fn, Chr$(34) & aName(l) & Chr$(34) & "=hex:" & _
                                                Replace(Trim$(aValue(l)), " ", ",")
361:        Next
362:        u = EnumValues(sPath, aName, aValue, REG_DWORD) - 1
363:        For l = 0 To u
364:            tmp = Hex$(aValue(l))
365:            If (Len(tmp) < 8) Then
366:                nuls = ""
367:                For x = 1 To 8 - Len(tmp)
368:                    nuls = nuls & "0"
369:                Next
370:                tmp = nuls & tmp
371:            End If
372:            Print #fn, Chr$(34) & aName(l) & Chr$(34) & "=dword:" & tmp
373:        Next
        
374:        Print #fn, ""
        
375:        On Error Resume Next
376:        Close #fn
377:        opened = False
        
378:        u = EnumKeys(sPath, keyName) - 1
379:        For l = 0 To u
380:            If (generateReg(sPath & "\" & keyName(l), sRegFile, Output) = False) _
                Then GoTo errH
381:        Next
        
382:    Close #fn
383:    opened = False
    
384:    generateReg = True
    Exit Function
errH:
    On Error Resume Next
    If (opened = True) Then Close #fn
    generateReg = False
'    LogError "generateReg", "clsRegistryAccess.cls", sPath & ", " & sRegFile & _
'                   ", [" & TypeName(Output) & "]", Err.Description, Err.Number, Erl
End Function
'----[ ImportFromReg ]----'
Public Function ImportFromReg(ByVal sRegFile As String) As Long
385:    On Error GoTo noexists
    
386:    Dim Lines() As String, i As Long, sTemp As String, FileNum As Integer
387:    Dim Args() As String, k As Long, sLine As String, l As Long, tmp As String
    
388:    CreateKeyIfDoesntExists = True 'vazno!
    
389:    If (Dir(sRegFile) = "") Or (sRegFile = vbNullString) Then 'fajl ne postoji!
noexists:
390:        InportFromReg = 0
391:        Exit Function
392:    End If
393:    On Error GoTo errH

394:    FileNum = FreeFile
395:    Open sRegFile For Binary As #FileNum
396:        sTemp = Input(LOF(FileNum), #FileNum)
397:    Close #FileNum
    
398:    Lines = Split(sTemp, vbCrLf) 'delimo u linije
    
399:    If (UCase$(Lines(0)) <> "REGEDIT4") Then
400:        InportFromReg = 0 'reg fajl nije validan!
401:        Exit Function
402:    End If

403:    For i = 1 To UBound(Lines)
404:        sLine = Replace(Trim$(Lines(i)), Chr$(34), vbNullString)

405:        If (Left$(sLine, 1) = "[") Then 'kljuc
406:            sLine = Mid$(sLine, 2, Len(sLine) - 2)
            
407:            If (Left$(sLine, 1) = "-") Then 'brisemo kljuc
408:                sTemp = Mid$(sLine, 2, Len(sLine) - 1)
409:                KillKey sTemp
410:            Else
411:                For k = i + 1 To UBound(Lines)
412:                    sTemp = Trim$(Replace(Lines(k), Chr$(34), ""))
                    
413:                    If (Left$(sTemp, 1) = "[") Then
414:                        i = k - 1
415:                        Exit For
416:                    End If
                    
417:                    If (sTemp = "") Or (InStr(1, sTemp, "=") < 1) Then GoTo jump
                    
418:                    Args = Split(sTemp, "=")
                    
419:                    If (Trim$(Args(1)) = "-") Then 'brisemo vrednost
420:                        KillValue sLine, Args(0)
421:                    Else 'upisujemo vrednost
422:                        If (LCase$(Left$(Args(1), 4)) = "hex:") Then 'binary
423:                            tmp = Replace(Mid$(Args(1), 5, Len(Args(1)) - 4), _
                                                                         ",", " ")
424:                            WriteBinary sLine, Args(0), tmp
425:                        ElseIf (LCase$(Left$(Args(1), 6)) = "dword:") Then 'DWORD
426:                            WriteDWORD sLine, Args(0), _
                                CLng(Val("&H" & Mid$(Args(1), 7, Len(Args(1)) - 6)))
427:                        Else 'string
428:                            WriteString sLine, Args(0), Args(1)
429:                            If (Args(0) = "@") And (Args(1) = "") Then _
                                KillValue sLine, "" '(value not set)
430:                        End If
431:                    End If
jump:
432:                Next
433:            End If
434:        End If
435:    Next
    
436:    InportFromReg = 1 'uspesno ubaceno u registry
437:    Exit Function
errH:
'    LogError "ImportFromReg", "clsRegistryAccess.cls", sRegFile, Err.Description, _
'                                                                 Err.Number, Erl
    Err.Clear
    Resume Next
End Function
'----[ StrToBin ]----'
Public Function StrToBin(sBin As String) As String
438: On Error GoTo errH
439:    Dim two() As String, q As Integer
440:    Dim bs As String, w As Integer
441:    sBin = Replace(sBin, " ", vbNullString) 'brisemo razmake
    
442:    If (sBin = vbNullString) Then Exit Function
    
443:    ReDim two(1 To Len(sBin)) As String
    
445:    w = 0
446:    For q = 1 To Len(sBin) Step 2 'dva po dva
447:        w = w + 1
448:        bs = Mid$(sBin, q, 2)
449:        If bs = "00" Then bs = vbNullChar
450:        two(w) = bs
451:    Next

452:    For q = 1 To UBound(two) / 2
453:        If two(q) = vbNullChar Then
454:            StrToBin = StrToBin & vbNullChar
455:        Else
456:            StrToBin = StrToBin & Chr$(Val("&H" & two(q)))
457:        End If
458:    Next
459:    Exit Function
errH:
'    LogError "StrToBin", "clsRegistryAccess.cls", sBin, Err.Description, _
'                                                        Err.Number, Erl
    Err.Clear
    Resume Next
End Function
'----[ BinToStr ]----'
Public Function BinToStr(sStr As String) As String
    'prebacuje npr. ">" u "BE 3E FF AB" - koristi se za binary vrednost
460: On Error GoTo errH
461:    Dim bs As String, ret As String, q As Integer, tStr As String
    
462:    ret = vbNullString
463:    For q = 1 To Len(sStr)
464:        bs = Mid$(sStr, q, 1)
465:        If bs = vbNullChar Then tStr = "00" Else tStr = CStr(Hex(Asc(bs)))
466:        If (Len(tStr) = 1) Then tStr = tStr & "0"
467:        ret = ret & " " & tStr
468:    Next
    
469:    BinToStr = ret
470:    Exit Function
errH:
'    LogError "BinToStr", "clsRegistryAccess.cls", sStr, Err.Description, _
'                                                        Err.Number, Erl
    Err.Clear
    Resume Next
End Function
'----[ isBinValid ]----'
Public Function isBinValid(ByVal sBin As String) As Boolean
471: On Error GoTo errH
472:    Dim z As Integer, sTmp As String, iAsc As Integer
    
473:    sBin = UCase$(Replace(sBin, " ", vbNullString))
    
474:    For z = 1 To Len(sBin)
475:        sTmp = Mid$(sBin, z, 1) 'char by char...
476:        iAsc = Asc(sTmp)
477:        Debug.Print iAsc
478:        If (iAsc < 48) Or ((iAsc > 57) And (iAsc < 65)) Or (iAsc > 70) Then
479:           isBinValid = False
480:           Exit Function
481:        End If
482:    Next
483:    isBinValid = True
484:    Exit Function
errH:
'    LogError "isBinValid", "clsRegistryAccess.cls", sBin, Err.Description, _
'                                                          Err.Number, Erl
    Err.Clear
    Resume Next
End Function
