Attribute VB_Name = "modMain"
Type FILEINFO
    nFilename   As String
    nOutputDir  As String
    nRun        As Integer
End Type

Dim pbData          As New PropertyBag
Dim FileCount       As Integer
Public ShowGUI      As Boolean
Public UsePassword  As Boolean
Public Password     As String
Public PRJ          As String

Public Function AddFile(cFile As FILEINFO, noFile As Integer) As Boolean
    On Error GoTo errH
    
    Dim fn      As Integer
    Dim sBin    As String
    
    'proveravamo da li fajl postoji
    If (Dir(cFile.nFilename) = "") Then MsgBox "File" & vbCrLf & cFile.nFilename _
                    & vbCrLf & "not exists.", vbExclamation, "Error": GoTo proc_exit
    
    FileCount = noFile
    
    fn = FreeFile
    
    Open cFile.nFilename For Binary As #fn  'otvaramo fajl
        sBin = Input(LOF(fn), #fn) 'i ucitavamo ga u sBin
    Close #fn
    
        'upisujemo fajl u property 'b#' (#-broj fajla)
        pbData.WriteProperty "b" & FileCount, sBin
        sBin = ""
        'upisujemo output dir
        pbData.WriteProperty "o" & FileCount, Trim$(cFile.nOutputDir)
        'upisujemo Run parametar (0,1,2)
        pbData.WriteProperty "r" & FileCount, cFile.nRun
        
    AddFile = True 'uspesno ubacen fajl
    Exit Function
errH:
    MsgBox Err.Description, , "Error: " & Err.Number
proc_exit:
    AddFile = False
End Function
Public Sub Compile(sOutput As String)
    Dim fn      As Integer
    Dim pos     As Long
    Dim vData   As Variant
    
    If FileCount = 0 Then Exit Sub
    
    pbData.WriteProperty "u", FileCount
    pbData.WriteProperty "gui", ShowGUI
    pbData.WriteProperty "Project", PRJ
    
    If UsePassword And Password <> "" Then
        pbData.WriteProperty "p", True
        pbData.WriteProperty "0#0", Password
    Else
        pbData.WriteProperty "p", False
    End If
    
    vData = pbData.Contents
    fn = FreeFile
    
    Open sOutput For Binary As #fn 'otvaramo fajl u BINARY modu
        DoEvents 'za svaki slucaj...
        
        pos = LOF(fn) 'kraj fajla
        
        Seek #fn, pos 'pomeramo pointer na sam kraj
        
        Put #fn, , vData 'i dopisujemo pbData (u kom se nalaze fajlovi i podaci)
        Put #fn, , pos 'sada na kraj upisemo pocetak sa kog citamo pbData
        
    Close #fn
End Sub
Function BuildPath(sPath As String, sName As String) As String
    BuildPath = Replace(sPath & "\" & sName, "\\", "\")
End Function
